fan.web = {};
fan.web.Cookie = fan.sys.Obj.$extend(fan.sys.Obj);
fan.web.Cookie.prototype.$ctor = function()
{
  fan.sys.Obj.prototype.$ctor.call(this);
  var $this = this;
  this.m_path = "/";
  this.m_secure = false;
  return;
}
fan.web.Cookie.prototype.$typeof = function() { return fan.web.Cookie.$type; }
fan.web.Cookie.fromStr = function(s)
{
  var eq = fan.sys.Str.index(s,"=");
  if (eq == null)
  {
    throw fan.sys.ParseErr.make(s);
  }
  ;
  var name = fan.sys.Str.trim(fan.sys.Str.slice(s,fan.sys.Range.make(0,fan.sys.ObjUtil.coerce(eq,fan.sys.Int.$type),true)));
  var val = fan.sys.Str.trim(fan.sys.Str.slice(s,fan.sys.Range.make(fan.sys.Int.plus(fan.sys.ObjUtil.coerce(eq,fan.sys.Int.$type),1),-1)));
  if (fan.sys.ObjUtil.compareGE(fan.sys.Str.size(val),2) && fan.sys.ObjUtil.equals(fan.sys.Str.get(val,0),34) && fan.sys.ObjUtil.equals(fan.sys.Str.get(val,-1),34))
  {
    val = fan.web.WebUtil.fromQuotedStr(val);
  }
  ;
  return fan.web.Cookie.make(name,val);
}
fan.web.Cookie.make = function(name,val,f)
{
  var self = new fan.web.Cookie();
  fan.web.Cookie.make$(self,name,val,f);
  return self;
}
fan.web.Cookie.make$ = function(self,name,val,f)
{
  if (f === undefined) f = null;
  var $this = self;
  ;
  if (f != null)
  {
    f.call(self);
  }
  ;
  self.m_name = name;
  self.m_val = val;
  if (!fan.web.WebUtil.isToken(self.m_name) || fan.sys.ObjUtil.equals(fan.sys.Str.get(self.m_name,0),36))
  {
    throw fan.sys.ArgErr.make(fan.sys.Str.plus("Cookie name has illegal chars: ",val));
  }
  ;
  if (!fan.sys.Str.all(self.m_val,fan.sys.Func.make(
    fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("c","sys::Int",false)]),
    fan.sys.Bool.$type,
    function(c)
    {
      return fan.sys.ObjUtil.compareLE(32,c) && fan.sys.ObjUtil.compareLE(c,126) && fan.sys.ObjUtil.compareNE(c,59);
    })))
  {
    throw fan.sys.ArgErr.make(fan.sys.Str.plus("Cookie value has illegal chars: ",val));
  }
  ;
  if (fan.sys.ObjUtil.compareGE(fan.sys.Int.plus(fan.sys.Str.size(self.m_val),32),fan.web.WebUtil.m_maxTokenSize))
  {
    throw fan.sys.ArgErr.make("Cookie value too big");
  }
  ;
  return;
}
fan.web.Cookie.prototype.toStr = function()
{
  var s = fan.sys.StrBuf.make(64);
  s.add(this.m_name).add("=").add(fan.web.WebUtil.toQuotedStr(this.m_val));
  if (this.m_maxAge != null)
  {
    s.add(";Max-Age=").add(fan.sys.ObjUtil.coerce(this.m_maxAge.toSec(),fan.sys.Obj.$type.toNullable()));
    if (fan.sys.ObjUtil.compareLE(this.m_maxAge.ticks(),0))
    {
      s.add(";Expires=").add("Sat, 01 Jan 2000 00:00:00 GMT");
    }
    else
    {
      s.add(";Expires=").add(fan.sys.DateTime.nowUtc().plus(fan.sys.ObjUtil.coerce(this.m_maxAge,fan.sys.Duration.$type)).toHttpStr());
    }
    ;
  }
  ;
  if (this.m_domain != null)
  {
    s.add(";Domain=").add(this.m_domain);
  }
  ;
  if (this.m_path != null)
  {
    s.add(";Path=").add(this.m_path);
  }
  ;
  if (this.m_secure)
  {
    s.add(";Secure");
  }
  ;
  return s.toStr();
}
fan.web.Cookie.prototype.m_name = null;
fan.web.Cookie.prototype.m_val = null;
fan.web.Cookie.prototype.m_maxAge = null;
fan.web.Cookie.prototype.m_domain = null;
fan.web.Cookie.prototype.m_path = null;
fan.web.Cookie.prototype.m_secure = false;
fan.web.WebUtil = fan.sys.Obj.$extend(fan.sys.Obj);
fan.web.WebUtil.prototype.$ctor = function()
{
  fan.sys.Obj.prototype.$ctor.call(this);
  var $this = this;
}
fan.web.WebUtil.prototype.$typeof = function() { return fan.web.WebUtil.$type; }
fan.web.WebUtil.isToken = function(s)
{
  var $this = this;
  if (fan.sys.Str.isEmpty(s))
  {
    return false;
  }
  ;
  return fan.sys.Str.all(s,fan.sys.Func.make(
    fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("c","sys::Int",false)]),
    fan.sys.Bool.$type,
    function(c)
    {
      return fan.sys.ObjUtil.compareLT(c,127) && fan.web.WebUtil.m_tokenChars.get(c);
    }));
}
fan.web.WebUtil.toQuotedStr = function(s)
{
  var $this = this;
  var buf = fan.sys.StrBuf.make();
  buf.addChar(34);
  fan.sys.Str.each(s,fan.sys.Func.make(
    fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("c","sys::Int",false)]),
    fan.sys.Void.$type,
    function(c)
    {
      if (fan.sys.ObjUtil.compareLT(c,32) || fan.sys.ObjUtil.compareGT(c,126))
      {
        throw fan.sys.ArgErr.make(fan.sys.Str.plus("Invalid quoted str chars: ",s));
      }
      ;
      if (fan.sys.ObjUtil.equals(c,34))
      {
        buf.addChar(92);
      }
      ;
      buf.addChar(c);
      return;
    }));
  buf.addChar(34);
  return buf.toStr();
}
fan.web.WebUtil.fromQuotedStr = function(s)
{
  if (fan.sys.ObjUtil.compareLT(fan.sys.Str.size(s),2) || fan.sys.ObjUtil.compareNE(fan.sys.Str.get(s,0),34) || fan.sys.ObjUtil.compareNE(fan.sys.Str.get(s,-1),34))
  {
    throw fan.sys.ArgErr.make(fan.sys.Str.plus("Not quoted str: ",s));
  }
  ;
  return fan.sys.Str.replace(fan.sys.Str.slice(s,fan.sys.Range.make(1,-2)),"\\\"","\"");
}
fan.web.WebUtil.parseList = function(s)
{
  return fan.sys.Str.split(s,fan.sys.ObjUtil.coerce(44,fan.sys.Int.$type.toNullable()));
}
fan.web.WebUtil.parseHeaders = function($in)
{
  var headers = fan.sys.Map.fromLiteral([],[],fan.sys.Type.find("sys::Str"),fan.sys.Type.find("sys::Str"));
  headers.caseInsensitive$(true);
  var last = null;
  while (true)
  {
    var peek = $in.peek();
    if (fan.sys.ObjUtil.equals(peek,fan.web.WebUtil.m_CR))
    {
      break;
    }
    ;
    if (fan.sys.Int.isSpace(fan.sys.ObjUtil.coerce(peek,fan.sys.Int.$type)) && last != null)
    {
      headers = fan.sys.Str.plus(headers.get(fan.sys.ObjUtil.coerce(last,fan.sys.Str.$type)),fan.sys.Str.plus(" ",fan.sys.Str.trim($in.readLine())));
      continue;
    }
    ;
    var key = fan.sys.Str.trim(fan.web.WebUtil.token($in,58));
    var val = fan.sys.Str.trim(fan.web.WebUtil.token($in,fan.web.WebUtil.m_CR));
    if (fan.sys.ObjUtil.compareNE($in.read(),fan.web.WebUtil.m_LF))
    {
      throw fan.sys.ParseErr.make("Invalid CRLF line ending");
    }
    ;
    var dup = headers.get(key);
    if (dup == null)
    {
      headers.set(key,val);
    }
    else
    {
      headers.set(key,fan.sys.Str.plus(fan.sys.Str.plus(dup,","),val));
    }
    ;
    last = key;
  }
  ;
  if (fan.sys.ObjUtil.compareNE($in.read(),fan.web.WebUtil.m_CR) || fan.sys.ObjUtil.compareNE($in.read(),fan.web.WebUtil.m_LF))
  {
    throw fan.sys.ParseErr.make("Invalid CRLF headers ending");
  }
  ;
  return headers;
}
fan.web.WebUtil.token = function($in,sep)
{
  var $this = this;
  var tok = $in.readStrToken(fan.sys.ObjUtil.coerce(fan.web.WebUtil.m_maxTokenSize,fan.sys.Int.$type.toNullable()),fan.sys.Func.make(
    fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("ch","sys::Int",false)]),
    fan.sys.Bool.$type,
    function(ch)
    {
      return fan.sys.ObjUtil.equals(ch,sep);
    }));
  if (tok == null)
  {
    throw fan.sys.IOErr.make("Unexpected end of stream");
  }
  ;
  if (fan.sys.ObjUtil.compareGE(fan.sys.Str.size(tok),fan.web.WebUtil.m_maxTokenSize))
  {
    throw fan.sys.ParseErr.make("Token too big");
  }
  ;
  $in.read();
  return fan.sys.ObjUtil.coerce(tok,fan.sys.Str.$type);
}
fan.web.WebUtil.makeContentInStream = function(headers,$in)
{
  var $this = this;
  var cs = fan.sys.Charset.utf8();
  var ct = headers.get("Content-Type");
  if (ct != null)
  {
    cs = fan.sys.MimeType.fromStr(fan.sys.ObjUtil.coerce(ct,fan.sys.Str.$type)).charset();
  }
  ;
  var len = headers.get("Content-Length");
  if (len != null)
  {
    return fan.sys.ObjUtil.coerce(fan.sys.ObjUtil.$with(fan.web.WebUtil.makeFixedInStream($in,fan.sys.ObjUtil.coerce(fan.sys.Str.toInt(len),fan.sys.Int.$type)),fan.sys.ObjUtil.coerce(fan.sys.Func.make(
      fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("it","sys::InStream",false)]),
      fan.sys.Void.$type,
      function(it)
      {
        it.charset$(cs);
        return;
      }),fan.sys.Type.find("|sys::Obj->sys::Void|"))),fan.sys.InStream.$type);
  }
  ;
  if (fan.sys.Str.contains(fan.sys.Str.lower(headers.get("Transfer-Encoding","")),"chunked"))
  {
    return fan.sys.ObjUtil.coerce(fan.sys.ObjUtil.$with(fan.web.WebUtil.makeChunkedInStream($in),fan.sys.ObjUtil.coerce(fan.sys.Func.make(
      fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("it","sys::InStream",false)]),
      fan.sys.Void.$type,
      function(it)
      {
        it.charset$(cs);
        return;
      }),fan.sys.Type.find("|sys::Obj->sys::Void|"))),fan.sys.InStream.$type);
  }
  ;
  if (ct != null)
  {
    return $in;
  }
  ;
  return null;
}
fan.web.WebUtil.makeContentOutStream = function(headers,out)
{
  var $this = this;
  var cs = fan.sys.Charset.utf8();
  var ct = headers.get("Content-Type");
  if (ct != null)
  {
    cs = fan.sys.MimeType.fromStr(fan.sys.ObjUtil.coerce(ct,fan.sys.Str.$type)).charset();
  }
  ;
  var len = headers.get("Content-Length");
  if (len != null)
  {
    return fan.sys.ObjUtil.coerce(fan.sys.ObjUtil.$with(fan.web.WebUtil.makeFixedOutStream(out,fan.sys.ObjUtil.coerce(fan.sys.Str.toInt(len),fan.sys.Int.$type)),fan.sys.ObjUtil.coerce(fan.sys.Func.make(
      fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("it","sys::OutStream",false)]),
      fan.sys.Void.$type,
      function(it)
      {
        it.charset$(cs);
        return;
      }),fan.sys.Type.find("|sys::Obj->sys::Void|"))),fan.sys.OutStream.$type);
  }
  ;
  if (ct != null)
  {
    headers.set("Transfer-Encoding","chunked");
    return fan.sys.ObjUtil.coerce(fan.sys.ObjUtil.$with(fan.web.WebUtil.makeChunkedOutStream(out),fan.sys.ObjUtil.coerce(fan.sys.Func.make(
      fan.sys.List.make(fan.sys.Param.$type, [new fan.sys.Param("it","sys::OutStream",false)]),
      fan.sys.Void.$type,
      function(it)
      {
        it.charset$(cs);
        return;
      }),fan.sys.Type.find("|sys::Obj->sys::Void|"))),fan.sys.OutStream.$type);
  }
  ;
  return null;
}
fan.web.WebUtil.makeFixedInStream = function($in,fixed)
{
  return fan.web.ChunkInStream.make($in,fan.sys.ObjUtil.coerce(fixed,fan.sys.Int.$type.toNullable()));
}
fan.web.WebUtil.makeChunkedInStream = function($in)
{
  return fan.web.ChunkInStream.make($in,null);
}
fan.web.WebUtil.makeFixedOutStream = function(out,fixed)
{
  return fan.web.FixedOutStream.make(out,fixed);
}
fan.web.WebUtil.makeChunkedOutStream = function(out)
{
  return fan.web.ChunkOutStream.make(out);
}
fan.web.WebUtil.parseMultiPart = function($in,boundary,cb)
{
  boundary = fan.sys.Str.plus("--",boundary);
  var line = $in.readLine();
  if (fan.sys.ObjUtil.equals(line,fan.sys.Str.plus(boundary,"--")))
  {
    return;
  }
  ;
  if (fan.sys.ObjUtil.compareNE(line,boundary))
  {
    throw fan.sys.IOErr.make(fan.sys.Str.plus("Expecting boundry line ",fan.sys.Str.toCode(boundary)));
  }
  ;
  while (true)
  {
    var headers = fan.web.WebUtil.parseHeaders($in);
    var partIn = fan.web.MultiPartInStream.make($in,boundary);
    cb.call(headers,partIn);
    if (partIn.m_endOfParts)
    {
      break;
    }
    ;
  }
  ;
  return;
}
fan.web.WebUtil.make = function()
{
  var self = new fan.web.WebUtil();
  fan.web.WebUtil.make$(self);
  return self;
}
fan.web.WebUtil.make$ = function(self)
{
  return;
}
fan.web.WebUtil.static$init = function()
{
  if (true)
  {
    var m = fan.sys.List.make(fan.sys.Bool.$type);
    for (var i = 0; fan.sys.ObjUtil.compareLT(i,127); i = fan.sys.Int.increment(i))
    {
      m.add(fan.sys.ObjUtil.coerce(fan.sys.ObjUtil.compareGT(i,32),fan.sys.Obj.$type.toNullable()));
    }
    ;
    m.set(40,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(41,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(60,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(62,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(64,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(44,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(59,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(58,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(92,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(34,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(47,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(91,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(93,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(63,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(61,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(123,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(125,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(32,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    m.set(9,fan.sys.ObjUtil.coerce(false,fan.sys.Obj.$type.toNullable()));
    fan.web.WebUtil.m_tokenChars = fan.sys.ObjUtil.coerce((function($this) { var $_u42 = m; if ($_u42 == null) return null; return fan.sys.ObjUtil.toImmutable($_u42); })(this),fan.sys.Type.find("sys::Bool[]"));
  }
  ;
  fan.web.WebUtil.m_CR = 13;
  fan.web.WebUtil.m_LF = 10;
  fan.web.WebUtil.m_HT = 9;
  fan.web.WebUtil.m_SP = 32;
  fan.web.WebUtil.m_maxTokenSize = 4096;
  return;
}
fan.web.WebUtil.m_tokenChars = null;
fan.web.WebUtil.m_CR = 0;
fan.web.WebUtil.m_LF = 0;
fan.web.WebUtil.m_HT = 0;
fan.web.WebUtil.m_SP = 0;
fan.web.WebUtil.m_maxTokenSize = 0;
fan.web.$pod = fan.sys.Pod.$add('web');
with (fan.web.$pod)
{
  fan.web.Cookie.$type = $at('Cookie','sys::Obj',[],4098);
  fan.web.WebUtil.$type = $at('WebUtil','sys::Obj',[],4096);
  fan.web.Cookie.$type.$af('name',36866,'sys::Str').$af('val',36866,'sys::Str').$af('maxAge',36866,'sys::Duration?').$af('domain',36866,'sys::Str?').$af('path',36866,'sys::Str?').$af('secure',36866,'sys::Bool').$am('fromStr',20482).$am('make',4100).$am('toStr',135680);
  fan.web.WebUtil.$type.$af('tokenChars',50178,'sys::Bool[]').$af('CR',49218,'sys::Int').$af('LF',49218,'sys::Int').$af('HT',49218,'sys::Int').$af('SP',49218,'sys::Int').$af('maxTokenSize',49218,'sys::Int').$am('isToken',20482).$am('toQuotedStr',20482).$am('fromQuotedStr',20482).$am('parseList',20482).$am('parseHeaders',20482).$am('token',17410).$am('makeContentInStream',20482).$am('makeContentOutStream',20482).$am('makeFixedInStream',20482).$am('makeChunkedInStream',20482).$am('makeFixedOutStream',20482).$am('makeChunkedOutStream',20482).$am('parseMultiPart',20482).$am('make',69636).$am('static$init',82946);
}
fan.web.WebUtil.static$init();
